{% extends 'base.html' %}

{% load widget_tweaks %}

{% load param %}
{% load url_link %}
{% block content %}
<div class="breadcrumb">
    <a href="/"><i class="fas fa-home bread"></i>&nbsp;</a>
        &nbsp;›&nbsp;<b title="{{project.name}}" data-intro='Hello step one!' >{{ project.name|truncatechars:40}}</b>
    </div>
<section>

    {% if progress_bar == 1 %}
    <div class="progress-project">
        <h6 class="title-progress">Data distribution</h6>
        <div class="progress " style="height: 20px;">

            {% for space in space_info_list %}
            {% if space.tool != -1 %}
            <div data-toggle="popover" data-trigger="hover" data-placement="top"
            title="<strong>{{space.tool_name}}</strong>" data-container="body" data-html="true"
            data-content="size: <strong>{{space.size_total}}</strong>"
            class="progress-bar progress-bar-striped"
                role="progressbar" aria-valuenow="{{space.percent_space}}" aria-valuemin="0" aria-valuemax="100"
                style="background-color: {{space.color}}; width: {{space.percent_space | safe}}%; color:#000000"> <b>{{space.tool_name}}</b>

            </div>
            {% endif %}
            {% endfor %}
        </div>
        <div class="legend">
            {% for space in space_info_list %}
            {% if forloop.last %}
            <b>{{space.tool_name}}</b>: {{space.size_total}}
            {% else %}
            <b>{{space.tool_name}}</b>: {{space.size_total}} /
            {% endif %}
            {% endfor %}
        </div>
    </div>
    {% endif %}
    <div class="row">
        <div class="col-sm-6">
        </div>
    </div>
    {% comment %} {% include "projects/display_items_tree.html" with items=project.items %} {% endcomment %}
    {% include "projects/display_tree.html" with items=dict_investigations perms=perms %}


    {% if project.items %}
    <button class="btn btn-outline-primary btn-sm" type="button" onclick="expand()">Expand All</button>
    <button class="btn btn-outline-primary btn-sm" type="button" onclick="collapse()">Collapse All</button>

    <script>
        function expand() {
            $('.collapse').collapse('show');
        }

        function collapse() {
            $('.collapse').collapse('hide');
        }
    </script>
    {% else %}
    <h3>Your project "{{project.name}}" is empty, </h3>
    <h5>please start by adding a <a href="{% url 'core:add-investigation' project.id %}" style="color:blue"> new investigation </a></h5>

    {% endif %}

    <script>
        if (typeof jQuery !== 'undefined') {
            console.log('jQuery Loaded');
        } else {
            console.log('not loaded yet');
        }
    </script>

    <script>
        $(document).ready(function () {
            console.log(localStorage);
            //If shown.bs.collapse add the unique id to local storage
            $(".collapse").on("shown.bs.collapse", function () {
                localStorage.setItem("coll_" + this.id, true);
            });
            //If hidden.bs.collaspe remove the unique id from local storage
            $(".collapse").on("hidden.bs.collapse", function () {
                localStorage.removeItem("coll_" + this.id);
            });
            //If the key exists and is set to true, show the collapsed, otherwise hide
            $(".collapse").each(function () {
                if (localStorage.getItem("coll_" + this.id) == "true") {
                    $(this).collapse("show");
                } else {
                    $(this).collapse("hide");
                }
            });
        });
    </script>

<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js">
    var isHidden = "isHidden";
</script>
<script type = "text/JavaScript" src = " https://MomentJS.com/downloads/moment.js"></script>
<script>
function removeSpin() {
    $("#refresh_btn").find(".fa-sync-alt").removeClass("fa-spin");
    }
$('body').on('click','.fa-sync-alt',function() {
    $("#refresh_btn").find(".fa-sync-alt").addClass("fa-spin");
    setTimeout(function(){
        removeSpin();
    }, 2000);
    });
</script>

<div id="tasksVueApp">
    <button v-if="isHidden" id="async_card" class="btn btn-outline-primary btn-sm task-button" v-on:click="isHidden = !isHidden; loadTasks()"><i class="fa fa-chevron-up fa-1x ic-w mx-1  "></i>Asynchronous tasks</button>
    <section v-if="!isHidden">
    <div id="async" class="async_task table-wrapper display-table-example">
        <div class="raw">
        <span class="async_task_title">Latest Asynchronous tasks <span class="badge badge-secondary">[[nb]]</span></span>
        <button class="btn btn-outline-primary btn-sm async_btn" v-on:click="isHidden = !isHidden"><i class="fa fa-chevron-down fa-1x ic-w mx-1"></i></button>
        <button class="btn btn-outline-primary btn-sm async_btn"><a href='{% url 'core:async-tasks' project_id=project.id %}' target="_blank"> All asynchronous tasks</a></button>
        <button id="refresh_btn" class="btn btn-outline-primary btn-sm async_btn" v-on:click="loadTasks();"><i class="fas fa-sync-alt"></i></button>
        </div>

    <table id="test" class="table table-striped table-bordered table-hover async_task2">
        <thead>
            <tr>
                <th>Description</th>
                <th>Openlink selected object</th>
                <th>Result</th>
                <th>Status</th>
                <th>User</th>
                <th>Started</th>
                <th>Ended</th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="task in tasks" :key="task.id">
                <td>[[task.description]]</td>
                <td><u><a class="bread" v-bind:href="task.get_target_url" target="_blank">[[task.get_target_name]]</u></td>
                <td>[[ task.result ]]</a></td>
                <td>[[task.status]]</td>
                <td>[[task.get_author_name]]</td>
                <td v-bind:data-order="task.start_date">[[task.start_date_ago]]</td>
                <td>[[task.end_date]]</td>
            </tr>
        </tbody>
    </table>
    </div>
    </section>
</div>



<script>
    var app = new Vue({
      delimiters: ["[[", "]]"],
      el: "#tasksVueApp",

      data: function(){
        return {
          dt: null,
          tasks: [],
          timer: '',
          isHidden: true,
          nb: 0,
        };
      },

      watch: {
        tasks(val) {
        if (val && !this.timer && !this.isHidden) {
            this.timer = setInterval(this.loadTasks, 5000);
        }
        if (this.timer && this.isHidden) {
            clearInterval(this.timer);
            this.timer= '';
        }
          this.dt.destroy();
          this.$nextTick(() => {
            this.dt = $("#test.table").DataTable({
                fixedHeader: true,
                paging: false,
                searching: false,
                info: false,
                order: [[ 5, "desc" ]],
                responsive: true,
                scrollY: 200,
                }).columns.adjust();
          })
        }
      },

      methods : {
        loadTasks : function () {
          const _this = this;
          $.ajax({
            method: "GET",
            url: "/api/taskinfo/?project_id={{project.id}}&max_lenght=20&delta_minutes=30",
            dataType: "json",
            success: function (tasks){
                $.each(tasks, function (index) {
                    if (tasks[index].end_date){
                        var end_date = new Date(tasks[index].end_date);
                        var end_time_ago = moment(end_date).fromNow();
                        tasks[index].end_date = end_time_ago;
                    }
                    if (tasks[index].start_date){
                        var start_date = new Date(tasks[index].start_date);
                        var start_time_ago = moment(start_date).fromNow();
                        tasks[index].start_date_ago = start_time_ago;
                    }
                });
                _this.tasks = tasks;
                _this.nb = _this.tasks.length;
                _this.dt = $('#test.table').DataTable();
            }
           });
        }
      }
    });
</script>

<script>
    introJs().setOptions({
        dontShowAgain: true,
        dontShowAgainCookie: "introjs-dontShowAgain2",
        steps: [{
          title: 'Welcome',
          intro: 'Welcome to your new Openlink Project! 👋'
        },{
          element: document.querySelector('.edit_card'),
          title: 'Edit your project',
          intro: 'Edit Project name and description'
        },{
          element: document.querySelector('.user_card'),
          title: 'Add collaborators',
          intro: 'Add users to your project project. <br> There are 3 access rights levels: <br> - Administrator <br> - Contributor <br> - Collaborator'
        },{
          element: document.querySelector('.tool_card'),
          title: 'Add tools',
          intro: 'Add or edit tools linked to your project. <br> Each tool needs at least one user credentials.'
        },{
          element: document.getElementById("async_card"),
          title: 'Follow asynchronous tasks',
          intro: 'Some tasks are launched asynchronously. <br> Access the status of your latest Async tasks from here.'   
        },{
          element: document.querySelector('.add_investigation_card'),
          title: 'Create your first Investigation!',
          intro: 'Start by adding a new investigation,the main objectives of a project'
        }
        {% comment %} ,{
          element: document.querySelector('.'),
          intro: '“+” button will create a new study. <br> “Delete” button will remove the investigation'
        },{
          element: document.querySelector('.'),
          intro: 'Access your investigation page'
        },{
          element: document.querySelector('.'),
          intro: 'Click the “Add link” button to add a link to your investigation'
        } {% endcomment %}
        ]
      }).start();
</script>

{% endblock %}